Index: /trunk/doc/manual/en_US/user_BasicConcepts.xml
===================================================================
--- /trunk/doc/manual/en_US/user_BasicConcepts.xml	(revision 76078)
+++ /trunk/doc/manual/en_US/user_BasicConcepts.xml	(revision 76079)
@@ -89,6 +89,7 @@
           <emphasis role="bold">Windows 2000, Windows XP, Windows Server
           2003, Windows Vista, Windows Server 2008, Windows 7, Windows
-          8, Windows 8.1, Windows 10 RTM 10240, Windows Server
-          2012:</emphasis>
+          Server 2008 R2, Windows 8, Windows Server 2012, Windows 8.1,
+          Windows Server 2012 R2, Windows 10 (non-Insider Preview releases),
+          Windows Server 2016, Windows server 2019:</emphasis>
         </para>
 
@@ -98,7 +99,5 @@
             <para>
               Fully supports all versions, editions, and service packs,
-              including 64-bit versions under the preconditions for
-              MS-DOS, Windows 3.x, Windows 95, Windows 98, and Windows
-              ME.
+              including 64-bit versions.
             </para>
           </listitem>
Index: /trunk/doc/manual/en_US/user_Introduction.xml
===================================================================
--- /trunk/doc/manual/en_US/user_Introduction.xml	(revision 76078)
+++ /trunk/doc/manual/en_US/user_Introduction.xml	(revision 76079)
@@ -535,5 +535,5 @@
       <listitem>
         <para>
-          <emphasis role="bold">Windows hosts:</emphasis>
+          <emphasis role="bold">Windows hosts (64-bit):</emphasis>
         </para>
 
@@ -542,53 +542,89 @@
           <listitem>
             <para>
-              Windows Server 2008 (64-bit)
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Windows Server 2008 R2 (64-bit)
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Windows 7 (32-bit and 64-bit)
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Windows 8 (32-bit and 64-bit)
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Windows 8.1 (32-bit and 64-bit)
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Windows 10 RTM build 10240 (32-bit and 64-bit)
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Windows Server 2012 (64-bit)
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Windows Server 2012 R2 (64-bit)
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Windows Server 2016 (64-bit)
+              Windows 7
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows 8
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows 8.1
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows 10 RTM (1507) build 10240
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows 10 November Update (1511) build 10586
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows 10 Anniversary Update (1607) build 14393
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows 10 Creators Update (1703) build 15063
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows 10 Fall Creators Update (1709) build 16299
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows 10 April 2018 Update (1803) build 17134
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows 10 October 2018 Update (1809) build 17763
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows Server 2008 R2
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows Server 2012
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows Server 2012 R2
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows Server 2016
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Windows Server 2019
             </para>
           </listitem>
@@ -606,16 +642,4 @@
           <listitem>
             <para>
-              10.10 (Yosemite)
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              10.11 (El Capitan)
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
               10.12 (Sierra)
             </para>
@@ -625,4 +649,10 @@
             <para>
               10.13 (High Sierra)
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              10.14 (Mojave)
             </para>
           </listitem>
@@ -639,6 +669,5 @@
       <listitem>
         <para>
-          <emphasis role="bold">Linux hosts (32-bit and
-          64-bit).</emphasis> Includes the following:
+          <emphasis role="bold">Linux hosts (64-bit).</emphasis> Includes the following:
         </para>
 
@@ -647,31 +676,29 @@
           <listitem>
             <para>
-              Ubuntu 14.04 LTS, 16.04 LTS, and 17.04
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Debian GNU/Linux 7 ("Wheezy"), 8 ("Jessie"), and 9
-              ("Stretch")
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Oracle Enterprise Linux 5, Oracle Linux 6, and Oracle
-              Linux 7
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Redhat Enterprise Linux 5, 6, and 7
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Fedora 25 and 26
+              Ubuntu 16.04 LTS, 18.04 LTS and 18.10
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Debian GNU/Linux 9 ("Stretch")
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Oracle Linux 6 and 7
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Redhat Enterprise Linux 6 and 7
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              Fedora 28 and 29
             </para>
           </listitem>
@@ -685,5 +712,11 @@
           <listitem>
             <para>
-              openSUSE 13.2
+              SUSE Linux Enterprise server 12 and 15
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              openSUSE Leap 42.3 and 15.0
             </para>
           </listitem>
@@ -718,10 +751,4 @@
             <para>
               Oracle Solaris 11
-            </para>
-          </listitem>
-
-          <listitem>
-            <para>
-              Oracle Solaris 10 8/11 and later
             </para>
           </listitem>