Index: /trunk/include/iprt/mangling.h
===================================================================
--- /trunk/include/iprt/mangling.h	(revision 76095)
+++ /trunk/include/iprt/mangling.h	(revision 76096)
@@ -3758,4 +3758,5 @@
 # define RTUtf16Cat                                     RT_MANGLER(RTUtf16Cat)
 # define RTUtf16CatAscii                                RT_MANGLER(RTUtf16CatAscii)
+# define RTUtf16Chr                                     RT_MANGLER(RTUtf16Chr)
 # define RTUtf16End                                     RT_MANGLER(RTUtf16End)
 # define RTUtf16ICmpAscii                               RT_MANGLER(RTUtf16ICmpAscii)
Index: /trunk/include/iprt/utf16.h
===================================================================
--- /trunk/include/iprt/utf16.h	(revision 76095)
+++ /trunk/include/iprt/utf16.h	(revision 76096)
@@ -264,4 +264,15 @@
  */
 RTDECL(PCRTUTF16) RTUtf16End(PCRTUTF16 pwszString, size_t cwcMax);
+
+/**
+ * Finds a give UTF-16 character in a UTF-16 string.
+ *
+ * @returns Pointer to the first occurence of @a wc.
+ * @returns NULL if @a wc was not found.
+ *
+ * @param   pwszString  The string to search.
+ * @param   wc          The UTF-16 character to search for.
+ */
+RTDECL(PRTUTF16) RTUtf16Chr(PCRTUTF16 pwszString, RTUTF16 wc);
 
 /**
Index: /trunk/src/VBox/Runtime/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Runtime/Makefile.kmk	(revision 76095)
+++ /trunk/src/VBox/Runtime/Makefile.kmk	(revision 76096)
@@ -572,4 +572,5 @@
 	common/string/RTUtf16Cat.cpp \
 	common/string/RTUtf16CatAscii.cpp \
+	common/string/RTUtf16Chr.cpp \
 	common/string/RTUtf16CmpAscii.cpp \
 	common/string/RTUtf16ICmpAscii.cpp \
@@ -3067,4 +3068,5 @@
 RuntimeR0Drv_SOURCES.os2 = \
 	common/path/RTPathFilenameUtf16.cpp \
+	common/string/RTUtf16Chr.cpp \
 	common/string/memchr.asm \
 	common/string/memcmp.asm \
Index: /trunk/src/VBox/Runtime/common/string/RTUtf16Chr.cpp
===================================================================
--- /trunk/src/VBox/Runtime/common/string/RTUtf16Chr.cpp	(revision 76096)
+++ /trunk/src/VBox/Runtime/common/string/RTUtf16Chr.cpp	(revision 76096)
@@ -0,0 +1,52 @@
+/* $Id$ */
+/** @file
+ * IPRT - RTUtf16Chr.
+ */
+
+/*
+ * Copyright (C) 2014-2017 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
+#include <iprt/string.h>
+#include "internal/iprt.h"
+
+
+RTDECL(PRTUTF16) RTUtf16Chr(PCRTUTF16 pwszString, RTUTF16 wc)
+{
+    for (;;)
+    {
+        RTUTF16 wcSrc = *pwszString;
+        if (wcSrc != wc)
+        {
+            if (wcSrc != '\0')
+                pwszString++;
+            else
+                return NULL;
+        }
+        else
+            return (PRTUTF16)pwszString;
+    }
+}
+RT_EXPORT_SYMBOL(RTUtf16Chr);
+