Index: trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 76202)
+++ trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 76203)
@@ -1175,5 +1175,5 @@
     switch (enmDetailsElementOptionTypeNetwork)
     {
-        case UIExtraDataMetaDefs::DetailsElementOptionTypeNetwork_NotAttached:     strResult = QApplication::translate("VBoxGlobal", "Not Attached"); break;
+        case UIExtraDataMetaDefs::DetailsElementOptionTypeNetwork_NotAttached:     strResult = QApplication::translate("VBoxGlobal", "Not Attached", "network adapter"); break;
         case UIExtraDataMetaDefs::DetailsElementOptionTypeNetwork_NAT:             strResult = QApplication::translate("VBoxGlobal", "NAT"); break;
         case UIExtraDataMetaDefs::DetailsElementOptionTypeNetwork_BridgetAdapter:  strResult = QApplication::translate("VBoxGlobal", "Bridget Adapter"); break;
@@ -1236,5 +1236,5 @@
     switch (enmDetailsElementOptionTypeSerial)
     {
-        case UIExtraDataMetaDefs::DetailsElementOptionTypeSerial_Disconnected: strResult = QApplication::translate("VBoxGlobal", "Disconnected"); break;
+        case UIExtraDataMetaDefs::DetailsElementOptionTypeSerial_Disconnected: strResult = QApplication::translate("VBoxGlobal", "Disconnected", "serial port"); break;
         case UIExtraDataMetaDefs::DetailsElementOptionTypeSerial_HostPipe:     strResult = QApplication::translate("VBoxGlobal", "Host Pipe"); break;
         case UIExtraDataMetaDefs::DetailsElementOptionTypeSerial_HostDevice:   strResult = QApplication::translate("VBoxGlobal", "Host Device"); break;
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlWidget.cpp	(revision 76202)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlWidget.cpp	(revision 76203)
@@ -88,5 +88,5 @@
         if (sessionTreeItem)
         {
-            pSessionCloseAction = menu->addAction(UIVMInformationDialog::tr("Close Session"));
+            pSessionCloseAction = menu->addAction(tr("Close Session"));
             if (pSessionCloseAction)
                 connect(pSessionCloseAction, &QAction::triggered,
@@ -99,5 +99,5 @@
         if (processTreeItem)
         {
-            pProcessTerminateAction = menu->addAction(UIVMInformationDialog::tr("Terminate Process"));
+            pProcessTerminateAction = menu->addAction(tr("Terminate Process"));
             if (pProcessTerminateAction)
                 connect(pProcessTerminateAction, &QAction::triggered,
@@ -107,9 +107,9 @@
             menu->addSeparator();
         // Add actions to expand/collapse all tree items
-        QAction *pExpandAllAction = menu->addAction(UIVMInformationDialog::tr("Expand All"));
+        QAction *pExpandAllAction = menu->addAction(tr("Expand All"));
         if (pExpandAllAction)
             connect(pExpandAllAction, &QAction::triggered,
                     this, &UIGuestControlTreeWidget::sltExpandAll);
-        QAction *pCollapseAllAction = menu->addAction(UIVMInformationDialog::tr("Collapse All"));
+        QAction *pCollapseAllAction = menu->addAction(tr("Collapse All"));
         if (pCollapseAllAction)
             connect(pCollapseAllAction, &QAction::triggered,
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIFDCreationDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIFDCreationDialog.cpp	(revision 76202)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIFDCreationDialog.cpp	(revision 76203)
@@ -69,20 +69,20 @@
 void UIFDCreationDialog::retranslateUi()
 {
-    setWindowTitle(QApplication::translate("UIMediumManager", "Create a Floppy Disk"));
+    setWindowTitle(tr("Create a Floppy Disk"));
     if (m_pPathLabel)
-        m_pPathLabel->setText(QApplication::translate("UIMediumManager", "File Path:"));
+        m_pPathLabel->setText(tr("File Path:"));
     if (m_pSizeLabel)
-        m_pSizeLabel->setText(QApplication::translate("UIMediumManager", "Size:"));
+        m_pSizeLabel->setText(tr("Size:"));
     if (m_pButtonBox)
         m_pButtonBox->button(QDialogButtonBox::Ok)->setText("Create");
     if (m_pFormatCheckBox)
-        m_pFormatCheckBox->setText(QApplication::translate("UIMediumManager", "Format disk as FAT12"));
+        m_pFormatCheckBox->setText(tr("Format disk as FAT12"));
     if (m_pSizeCombo)
     {
-        //m_pSizeCombo->setItemText(FDSize_2_88M, QApplication::translate("UIMediumManager", "2.88M"));
-        m_pSizeCombo->setItemText(FDSize_1_44M, QApplication::translate("UIMediumManager", "1.44M"));
-        m_pSizeCombo->setItemText(FDSize_1_2M, QApplication::translate("UIMediumManager", "1.2M"));
-        m_pSizeCombo->setItemText(FDSize_720K, QApplication::translate("UIMediumManager", "720K"));
-        m_pSizeCombo->setItemText(FDSize_360K, QApplication::translate("UIMediumManager", "360K"));
+        //m_pSizeCombo->setItemText(FDSize_2_88M, tr("2.88M"));
+        m_pSizeCombo->setItemText(FDSize_1_44M, tr("1.44M"));
+        m_pSizeCombo->setItemText(FDSize_1_2M, tr("1.2M"));
+        m_pSizeCombo->setItemText(FDSize_720K, tr("720K"));
+        m_pSizeCombo->setItemText(FDSize_360K, tr("360K"));
     }
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumSelector.cpp	(revision 76202)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumSelector.cpp	(revision 76203)
@@ -191,31 +191,31 @@
     if (m_pActionAdd)
     {
-        m_pActionAdd->setText(QApplication::translate("UIMediumManager", "&Add"));
-        m_pActionAdd->setToolTip(QApplication::translate("UIMediumManager", "Add Disk Image File"));
-        m_pActionAdd->setStatusTip(QApplication::translate("UIMediumManager", "Add disk image file"));
+        m_pActionAdd->setText(tr("&Add..."));
+        m_pActionAdd->setToolTip(tr("Add Disk Image"));
+        m_pActionAdd->setStatusTip(tr("Add existing disk image file"));
     }
 
     if (m_pActionCreate)
     {
-        m_pActionCreate->setText(QApplication::translate("UIMediumManager", "&Create"));
-        m_pActionCreate->setToolTip(QApplication::translate("UIMediumManager", "Create an Empty Disk Image"));
-        m_pActionCreate->setStatusTip(QApplication::translate("UIMediumManager", "Create an Empty Disk Image"));
+        m_pActionCreate->setText(tr("&Create..."));
+        m_pActionCreate->setToolTip(tr("Create Disk Image"));
+        m_pActionCreate->setStatusTip(tr("Create new disk image file"));
     }
 
     if (m_pActionRefresh)
     {
-        m_pActionRefresh->setText(QApplication::translate("UIMediumManager","Re&fresh"));
-        m_pActionRefresh->setToolTip(QApplication::translate("UIMediumManager","Refresh Disk Image Files (%1)").arg(m_pActionRefresh->shortcut().toString()));
-        m_pActionRefresh->setStatusTip(QApplication::translate("UIMediumManager","Refresh the list of disk image files"));
+        m_pActionRefresh->setText(tr("&Refresh"));
+        m_pActionRefresh->setToolTip(tr("Refresh Disk Image Files (%1)").arg(m_pActionRefresh->shortcut().toString()));
+        m_pActionRefresh->setStatusTip(tr("Refresh the list of disk image files"));
     }
 
     if (m_pButtonBox)
-        m_pButtonBox->button(QDialogButtonBox::Ok)->setText("Choose");
+        m_pButtonBox->button(QDialogButtonBox::Ok)->setText(tr("Choose"));
 
     if (m_pTreeWidget)
     {
-        m_pTreeWidget->headerItem()->setText(0, QApplication::translate("UIMediumManager","Name"));
-        m_pTreeWidget->headerItem()->setText(1, QApplication::translate("UIMediumManager","Virtual Size"));
-        m_pTreeWidget->headerItem()->setText(2, QApplication::translate("UIMediumManager","Actual Size"));
+        m_pTreeWidget->headerItem()->setText(0, tr("Name"));
+        m_pTreeWidget->headerItem()->setText(1, tr("Virtual Size"));
+        m_pTreeWidget->headerItem()->setText(2, tr("Actual Size"));
     }
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceImportEditorWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceImportEditorWidget.cpp	(revision 76202)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceImportEditorWidget.cpp	(revision 76203)
@@ -320,6 +320,6 @@
     UIApplianceEditorWidget::retranslateUi();
     if (m_pPathSelectorLabel)
-        m_pPathSelectorLabel->setText(UIWizardImportApp::tr("You can modify the base folder which will host all the virtual machines.\n"
-                                                            "Home folders can also be individually (per virtual machine)  modified."));
+        m_pPathSelectorLabel->setText(UIWizardImportApp::tr("You can modify the base folder which will host all the virtual machines. "
+                                                            "Home folders can also be individually (per virtual machine) modified."));
     if (m_pImportHDsAsVDI)
     {
@@ -337,12 +337,9 @@
                                 tr("Generate new MAC addresses for all network adapters"));
     m_pMACComboBox->setItemData(MACAddressImportPolicy_KeepAllMACs,
-                                tr("Include all network adapter MAC addresses in exported "
-                                                    "during cloning."), Qt::ToolTipRole);
+                                tr("Include all network adapter MAC addresses during cloning."), Qt::ToolTipRole);
     m_pMACComboBox->setItemData(MACAddressImportPolicy_KeepNATMACs,
-                                tr("Include only NAT network adapter MAC addresses "
-                                                    "during cloning."), Qt::ToolTipRole);
+                                tr("Include only NAT network adapter MAC addresses during cloning."), Qt::ToolTipRole);
     m_pMACComboBox->setItemData(MACAddressImportPolicy_StripAllMACs,
-                                tr("Generate new MAC addresses for all network adapters "
-                                                    "during cloning."), Qt::ToolTipRole);
+                                tr("Generate new MAC addresses for all network adapters during cloning."), Qt::ToolTipRole);
 
     m_pAdditionalOptionsLabel->setText(tr("Additional Options:"));
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageBasic1.cpp	(revision 76202)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageBasic1.cpp	(revision 76203)
@@ -287,5 +287,5 @@
 {
     /* Translate page: */
-    setTitle(UIWizardCloneVM::tr("New machine name"));
+    setTitle(UIWizardCloneVM::tr("New machine name and path"));
 
     /* Translate widgets: */
@@ -310,12 +310,9 @@
                                 UIWizardCloneVM::tr("Generate new MAC addresses for all network adapters"));
     m_pMACComboBox->setItemData(MACAddressClonePolicy_KeepAllMACs,
-                                UIWizardCloneVM::tr("Include all network adapter MAC addresses in exported "
-                                                      "during cloning."), Qt::ToolTipRole);
+                                UIWizardCloneVM::tr("Include all network adapter MAC addresses during cloning."), Qt::ToolTipRole);
     m_pMACComboBox->setItemData(MACAddressClonePolicy_KeepNATMACs,
-                                UIWizardCloneVM::tr("Include only NAT network adapter MAC addresses "
-                                                      "during cloning."), Qt::ToolTipRole);
+                                UIWizardCloneVM::tr("Include only NAT network adapter MAC addresses during cloning."), Qt::ToolTipRole);
     m_pMACComboBox->setItemData(MACAddressClonePolicy_StripAllMACs,
-                                UIWizardCloneVM::tr("Generate new MAC addresses for all network adapters "
-                                                      "during cloning."), Qt::ToolTipRole);
+                                UIWizardCloneVM::tr("Generate new MAC addresses for all network adapters during cloning."), Qt::ToolTipRole);
 
     m_pAdditionalOptionsLabel->setText(UIWizardCloneVM::tr("Additional Options:"));
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageExpert.cpp	(revision 76202)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVMPageExpert.cpp	(revision 76203)
@@ -218,6 +218,5 @@
     m_pNameLabel->setText(UIWizardCloneVM::tr("Name:"));
     m_pPathLabel->setText(UIWizardCloneVM::tr("Path:"));
-
-    m_pCloneOptionsCnt->setTitle(UIWizardCloneVM::tr("Clone options"));
+    m_pCloneOptionsCnt->setTitle(UIWizardCloneVM::tr("Additional options"));
 
     /* Translate MAC address policy combo-box: */
@@ -230,12 +229,9 @@
                                 UIWizardCloneVM::tr("Generate new MAC addresses for all network adapters"));
     m_pMACComboBox->setItemData(MACAddressClonePolicy_KeepAllMACs,
-                                UIWizardCloneVM::tr("Include all network adapter MAC addresses in exported "
-                                                      "during cloning."), Qt::ToolTipRole);
+                                UIWizardCloneVM::tr("Include all network adapter MAC addresses during cloning."), Qt::ToolTipRole);
     m_pMACComboBox->setItemData(MACAddressClonePolicy_KeepNATMACs,
-                                UIWizardCloneVM::tr("Include only NAT network adapter MAC addresses "
-                                                      "during cloning."), Qt::ToolTipRole);
+                                UIWizardCloneVM::tr("Include only NAT network adapter MAC addresses during cloning."), Qt::ToolTipRole);
     m_pMACComboBox->setItemData(MACAddressClonePolicy_StripAllMACs,
-                                UIWizardCloneVM::tr("Generate new MAC addresses for all network adapters "
-                                                      "during cloning."), Qt::ToolTipRole);
+                                UIWizardCloneVM::tr("Generate new MAC addresses for all network adapters during cloning."), Qt::ToolTipRole);
 
     m_pAdditionalOptionsLabel->setText(UIWizardCloneVM::tr("Additional Options:"));
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp	(revision 76202)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp	(revision 76203)
@@ -1095,12 +1095,9 @@
                                 UIWizardExportApp::tr("Strip all network adapter MAC addresses"));
     m_pMACComboBox->setItemData(MACAddressPolicy_KeepAllMACs,
-                                UIWizardExportApp::tr("Include all network adapter MAC addresses in exported "
-                                                      "appliance archive."), Qt::ToolTipRole);
+                                UIWizardExportApp::tr("Include all network adapter MAC addresses in exported appliance archive."), Qt::ToolTipRole);
     m_pMACComboBox->setItemData(MACAddressPolicy_StripAllNonNATMACs,
-                                UIWizardExportApp::tr("Include only NAT network adapter MAC addresses in "
-                                                      "exported appliance archive."), Qt::ToolTipRole);
+                                UIWizardExportApp::tr("Include only NAT network adapter MAC addresses in exported appliance archive."), Qt::ToolTipRole);
     m_pMACComboBox->setItemData(MACAddressPolicy_StripAllMACs,
-                                UIWizardExportApp::tr("Strip all network adapter MAC addresses from exported "
-                                                      "appliance archive."), Qt::ToolTipRole);
+                                UIWizardExportApp::tr("Strip all network adapter MAC addresses from exported appliance archive."), Qt::ToolTipRole);
 
     /* Translate addtional stuff: */
@@ -1207,7 +1204,7 @@
         m_pLabelSettings->setText(UIWizardExportApp::
                                   tr("<p>Please choose one of cloud service accounts you have registered to export virtual "
-                                     "machines to.  Make sure profile settings reflected in the underlying table are valid.  "
+                                     "machines to. Make sure profile settings reflected in the underlying table are valid. "
                                      "They will be used to establish network connection required to upload your virtual machine "
-                                     "files to a remote cloud facility."));
+                                     "files to a remote cloud facility.</p>"));
         m_pAccountComboBox->setFocus();
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 76202)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 76203)
@@ -431,10 +431,8 @@
     m_pFormatComboBox->setItemText(1, UIWizardExportApp::tr("Open Virtualization Format 1.0"));
     m_pFormatComboBox->setItemText(2, UIWizardExportApp::tr("Open Virtualization Format 2.0"));
-    m_pFormatComboBox->setItemText(3, UIWizardExportApp::tr("Oracle Cloud Infrastructure - Classic"));
     m_pFormatComboBox->setItemData(0, UIWizardExportApp::tr("Write in legacy OVF 0.9 format for compatibility "
                                                             "with other virtualization products."), Qt::ToolTipRole);
     m_pFormatComboBox->setItemData(1, UIWizardExportApp::tr("Write in standard OVF 1.0 format."), Qt::ToolTipRole);
     m_pFormatComboBox->setItemData(2, UIWizardExportApp::tr("Write in new OVF 2.0 format."), Qt::ToolTipRole);
-    m_pFormatComboBox->setItemData(3, UIWizardExportApp::tr("Write in Oracle Cloud Infrastructure - Classic format."), Qt::ToolTipRole);
     /* Translate received values of Format combo-box.
      * We are enumerating starting from 0 for simplicity: */
@@ -455,12 +453,9 @@
                                 UIWizardExportApp::tr("Strip all network adapter MAC addresses"));
     m_pMACComboBox->setItemData(MACAddressPolicy_KeepAllMACs,
-                                UIWizardExportApp::tr("Include all network adapter MAC addresses to exported "
-                                                      "appliance archive."), Qt::ToolTipRole);
+                                UIWizardExportApp::tr("Include all network adapter MAC addresses in exported appliance archive."), Qt::ToolTipRole);
     m_pMACComboBox->setItemData(MACAddressPolicy_StripAllNonNATMACs,
-                                UIWizardExportApp::tr("Include only NAT network adapter MAC addresses to "
-                                                      "exported appliance archive."), Qt::ToolTipRole);
+                                UIWizardExportApp::tr("Include only NAT network adapter MAC addresses in exported appliance archive."), Qt::ToolTipRole);
     m_pMACComboBox->setItemData(MACAddressPolicy_StripAllMACs,
-                                UIWizardExportApp::tr("Strip all network adapter MAC addresses from exported "
-                                                      "appliance archive."), Qt::ToolTipRole);
+                                UIWizardExportApp::tr("Strip all network adapter MAC addresses from exported appliance archive."), Qt::ToolTipRole);
 
     /* Translate addtional stuff: */