Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 76205)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 76208)
@@ -1211,4 +1211,5 @@
 	src/snapshots/UISnapshotDetailsWidget.cpp \
 	src/snapshots/UISnapshotPane.cpp \
+	src/widgets/UIApplianceEditorWidget.cpp \
 	src/widgets/UIMenuToolBar.cpp \
 	src/widgets/UITabBar.cpp \
@@ -1245,7 +1246,10 @@
 	src/guestctrl/UIGuestProcessControlWidget.cpp \
 	src/guestctrl/UIFileManagerHostTable.cpp \
+	src/settings/global/UIGlobalSettingsExtension.cpp \
 	src/settings/global/UIGlobalSettingsInput.cpp \
+	src/settings/global/UIGlobalSettingsNetwork.cpp \
 	src/settings/machine/UIMachineSettingsNetwork.cpp \
 	src/settings/machine/UIMachineSettingsSerial.cpp \
+	src/settings/machine/UIMachineSettingsSF.cpp \
 	src/settings/machine/UIMachineSettingsStorage.cpp \
 	src/settings/machine/UIMachineSettingsUSB.cpp \
@@ -1320,7 +1324,10 @@
 	src/medium/UIMediumEnumerator.cpp \
 	src/medium/UIMediumSelector.cpp \
+	src/settings/global/UIGlobalSettingsExtension.cpp \
 	src/settings/global/UIGlobalSettingsInput.cpp \
+	src/settings/global/UIGlobalSettingsNetwork.cpp \
 	src/settings/machine/UIMachineSettingsNetwork.cpp \
 	src/settings/machine/UIMachineSettingsSerial.cpp \
+	src/settings/machine/UIMachineSettingsSF.cpp \
 	src/settings/machine/UIMachineSettingsStorage.cpp \
 	src/settings/machine/UIMachineSettingsUSB.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsExtension.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsExtension.cpp	(revision 76205)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsExtension.cpp	(revision 76208)
@@ -116,4 +116,6 @@
 class UIExtensionPackageItem : public QITreeWidgetItem
 {
+    Q_OBJECT;
+
 public:
 
@@ -478,2 +480,4 @@
 }
 
+
+#include "UIGlobalSettingsExtension.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.cpp	(revision 76205)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.cpp	(revision 76208)
@@ -60,4 +60,6 @@
 class UIItemNetworkNAT : public QITreeWidgetItem, public UIDataSettingsGlobalNetworkNAT
 {
+    Q_OBJECT;
+
 public:
 
@@ -1010,2 +1012,4 @@
 }
 
+
+#include "UIGlobalSettingsNetwork.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp	(revision 76205)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp	(revision 76208)
@@ -99,4 +99,6 @@
 class SFTreeViewItem : public QITreeWidgetItem, public UIDataSettingsSharedFolder
 {
+    Q_OBJECT;
+
 public:
 
@@ -1113,2 +1115,4 @@
 }
 
+
+#include "UIMachineSettingsSF.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsUSB.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsUSB.cpp	(revision 76205)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsUSB.cpp	(revision 76208)
@@ -256,4 +256,6 @@
 class UIUSBFilterItem : public QITreeWidgetItem, public UIDataSettingsMachineUSBFilter
 {
+    Q_OBJECT;
+
 public:
 
@@ -1333,4 +1335,4 @@
 }
 
+
 #include "UIMachineSettingsUSB.moc"
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp	(revision 76205)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp	(revision 76208)
@@ -52,4 +52,6 @@
 class UIApplianceModelItem : public QITreeViewItem
 {
+    Q_OBJECT;
+
 public:
 
@@ -1892,2 +1894,5 @@
     m_pModel->setVirtualSystemBaseFolder(path);
 }
+
+
+#include "UIApplianceEditorWidget.moc"